﻿Imports System.ComponentModel
Imports System.Text
Imports Goldammer
Imports System.IO
Imports System.Windows.Forms.DataVisualization.Charting
Imports Goldammer.MAIExtensions.DAQ
Imports System.Globalization
Imports System.Data.SqlServerCe
Imports System.Data.Common
Imports NI_DDC_NET20_DLL
Imports System.Data.SqlClient

Namespace DAQExtensionTest

	Partial Public Class FormDataSinkTest
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub
        Private dev As Goldammer.MAIDevice = Goldammer.MAI.Devices(0)
		Private m_bRunning As Boolean = False
		Private Sub timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles timer1.Tick
			If Not m_bRunning Then
				Return
			End If
			If dev Is Nothing Then
				Return
			End If
			label6.Text = dev.ADChannels.DataSink.BurstCount.ToString()
		End Sub


		Private Sub StartMeasure()
			If dev Is Nothing Then
				Return
			End If
			buttonConvert.Enabled = False
			buttonReadRAW.Enabled = False
			dev.StartMeasure()
			m_bRunning = True
			button1.Text = "Stop"
		End Sub

		Private Sub StopMeasure()
			buttonConvert.Enabled = True
			buttonReadRAW.Enabled = True
			If dev Is Nothing Then
				Return
			End If
			m_bRunning = False
			dev.StopMeasure()
			dev.ADChannels.DataSink.Disable()
			dev.CTChannels.DataSink.Disable()

			CloseGolbalFilesAndConnectoins()
			dev.ADChannels.DataSink.Target = Nothing
			dev.CTChannels.DataSink.Target = Nothing
			dev.ClearAllChannelLists()
			button1.Text = "Start"

		End Sub

		Private Sub ConfigureMeasurementChannels()
			dev.ClearAllChannelLists()
			Dim numberOfADChannels As Integer = 0
			Int32.TryParse(textBoxAD.Text, numberOfADChannels)
			For i As Integer = 0 To numberOfADChannels - 1
				dev.ADChannels(i).CreateMeasurementChannel(OversamplingMode.Disabled, GainFactor.Disabled, True)

			Next i
			Dim numberOfcTChannels As Integer = 0
			Int32.TryParse(textBoxCT.Text, numberOfcTChannels)
			For i As Integer = 0 To numberOfcTChannels - 1
				dev.CTChannels(i).CreateImpulseCounter(010,ImpulseDirection.Up,SignalEdge.Rising,False)

			Next i

			Dim numberOfTTLChannels As Integer = 0
			Int32.TryParse(textBoxTTL.Text, numberOfTTLChannels)
			For i As Integer = 0 To numberOfTTLChannels - 1
				dev.TTLChannels(i).CreateMeasurementChannel(MeasurementChannelSyncMode.OnADChannels,TTLDigitalType.Bit)

			Next i
			dev.CTChannels.SetSampleRate(100)
			dev.ADChannels.SetSampleRate(100)
		End Sub

		Private Sub CloseGolbalFilesAndConnectoins()
			If myconn IsNot Nothing Then

				myconn.Close()
				myconn.Dispose()
				myconn = Nothing
			End If
			If myTDMS IsNot Nothing Then
				myTDMS.Write()

				myTDMS.Close()
				myTDMS.Dispose()
				myTDMS = Nothing
			End If
		End Sub

		Private Sub FormDataSinkTest_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			If dev Is Nothing Then
				Return
			End If

			labelDev.Text = dev.Info.SerialNumber
			dev.ClearAllChannelLists()

		End Sub


		#Region "Explicit Definition of a TDMSTarget"
		Private myTDMS As NI_DDCFile = Nothing
		Private Function CreateExplicitTDM() As IDataSinkTarget
			Dim dt1 As Date = Date.Now
			Dim NIChannelMap As New MAIDataSinkChannelMapTDMS()
			Try
				Dim Filename As String = "nationalMessdaten.tdm"
				If File.Exists(Filename) Then
					File.Delete(Filename)
				End If
				myTDMS = NI_DDC.CreateNIDDCFile(Filename, Path.GetExtension(Filename) = ".tdms", "NameTestMessung", "TestMessDecs", "TitelMess", "Frank")
				Try
					Dim adChannels As NI_DDCChannelGroup = myTDMS.AddChannelGroup("AD Kanäle", "Skaliert")
					adChannels.SetNIWaveFormProperty("None")
					For i As Integer = 0 To dev.ADChannels.MeasurementChannelsCount - 1
						Dim cad As MAIMeasurementChannelAD = dev.ADChannels.GetMeasurementChannel(CUInt(i))
						Dim c As NI_DDCChannel = adChannels.AddChannel(NI_DDCDatatype.Double, "AD" & i.ToString(), cad.Name, cad.Unit)
						c.SetNIProperties("ADKanal" & i.ToString(), 1, dt1, dt1, "t")
						c.SetNIWaveFormProperties(1.0 / dev.ADChannels.GetSampleRate(), 0, 0.0, dt1, "relative", cad.Name, cad.Unit)
						NIChannelMap.AddTargetForChannel(cad, myTDMS, c, Nothing)
					Next i

					myTDMS.AddProperty("Starttime", NI_DDCDatatype.Timestamp, dt1)
					NIChannelMap.SetTargetParameterForStartTime(myTDMS, "Starttime")


				Finally
					myTDMS.Write()


				End Try
			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try

			Return MAIDataSinkTarget.CreateTargetTDMS(NIChannelMap)
		End Function

		#End Region

		#Region "explicit definition od an SQL Target"
		Private myconn As DbConnection = Nothing

		Private Function CreateExplicitSQLCe() As IDataSinkTarget
			If File.Exists("MyFile.MAIdata") Then
				File.Delete("MyFile.MAIdata")
			End If
			Dim en As New SqlCeEngine("datasource=MyFile.MAIdata")
			en.CreateDatabase()
			en.Dispose()
			myconn = New SqlCeConnection("datasource=MyFile.MAIdata")
			myconn.Open()
			Dim nuCommand As DbCommand = myconn.CreateCommand()
			Dim createCmdPar As String = ""
			Dim createCmdParamNames As String = ""
			Dim createCmdColumNames As String = ""
			For i As Integer = 0 To dev.ADChannels.MeasurementChannelsCount - 1
				createCmdPar &= ", ADScaled" & i.ToString() & " Real "
				createCmdColumNames &= ", ADScaled" & i.ToString()
				createCmdParamNames &= ", @ADS" & i.ToString()
			Next i
			createCmdColumNames = createCmdColumNames.Substring(2)
			createCmdParamNames = createCmdParamNames.Substring(2)
			nuCommand.CommandText = "CREATE TABLE measureData  (ID BIGINT identity(1,1) PRIMARY KEY " & createCmdPar &");"
			nuCommand.ExecuteNonQuery()
			nuCommand.CommandText = "CREATE TABLE metaDataMaster  (ID INT identity(1,1) PRIMARY KEY, Start DateTime, Samplerate Real, NumberOfBursts BIGINT);"
			nuCommand.ExecuteNonQuery()
			'nuCommand.CommandText = "CREATE TABLE metaDataDetail  (ID INT identity(1,1) PRIMARY KEY, RefID INT, Name nvarchar(256), Value Real, Desc nvarchar(256));";
			'nuCommand.ExecuteNonQuery();


			Dim MyChannelmap As New MAIDataSinkChannelMapSQL()
			Dim InsertDataCommand As DbCommand = myconn.CreateCommand()
			InsertDataCommand.CommandText = "Insert into measureData (" & createCmdColumNames & ") values (" & createCmdParamNames & ");"

			For i As Integer = 0 To dev.ADChannels.MeasurementChannelsCount - 1
			   Dim param As DbParameter = InsertDataCommand.CreateParameter()
			   param.DbType = DbType.Double
			   param.ParameterName = "@ADS" & i.ToString()
			   InsertDataCommand.Parameters.Add(param)
			   MyChannelmap.AddDBStatementForData(dev.ADChannels.GetMeasurementChannel(CUInt(i)), InsertDataCommand, param, Nothing)
			Next i
			Dim InsertMDCommand As DbCommand = myconn.CreateCommand()
			InsertMDCommand.CommandText = "Insert into metaDataMaster (Start, Samplerate) values ( @StTime, @SamRat);"
			Dim paramStrat As DbParameter = InsertDataCommand.CreateParameter()
			paramStrat.DbType = DbType.DateTime
			paramStrat.ParameterName = "@StTime"
			paramStrat.Value = Date.MinValue
			InsertMDCommand.Parameters.Add(paramStrat)
			MyChannelmap.SetDBStatementForStartTime(InsertMDCommand, paramStrat)
			Dim paramSR As DbParameter = InsertDataCommand.CreateParameter()
			paramSR.DbType = DbType.Double
			paramSR.ParameterName = "@SamRat"
			paramSR.Value = -1.0

			InsertMDCommand.Parameters.Add(paramSR)
			MyChannelmap.SetDBStatementForSampleRate(InsertMDCommand, paramSR)
			Dim UpdateMDCommand As DbCommand = myconn.CreateCommand()
			UpdateMDCommand.CommandText = "update metaDataMaster set NumberOfBursts = @NumOBursts where ID = ALL (Select max(ID) from metaDataMaster);"
			Dim paramNB As DbParameter = UpdateMDCommand.CreateParameter()
			paramNB.DbType = DbType.Int64
			paramNB.ParameterName = "@NumOBursts"
			paramNB.Value = 0
			UpdateMDCommand.Parameters.Add(paramNB)
			MyChannelmap.SetDBStatementForNumberOfBurstsRecorded(UpdateMDCommand, paramNB)
			Return MAIDataSinkTarget.CreateTargetSQL(MyChannelmap)
		End Function

		#End Region



		Private Sub buttonConvert_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonConvert.Click
			If m_bRunning Then
				Return
			End If

		   MAIDataSinkTarget.ConvertRAW(MAIDataSinkTarget.CreateTargetCSV("KonvertierteMessdaten.csv", "KonvertierteKanalinfos.csv", False, ";"c, New CultureInfo("en-US"), False),"Rohdatenmessung")

		End Sub

		Private Sub buttonReadRAW_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonReadRAW.Click
			Dim Info As String = ""
			Try
				Dim dr As New MAIRAWDataReader("Rohdatenmessung")
				Info = "ADChannels: " & dr.ADChannelCount.ToString() & Environment.NewLine
				Info &= "Bursts    : " & dr.BurstCount.ToString() & Environment.NewLine

				Dim mittelwert(dr.ADChannelCount - 1) As Double
				For i As Integer = 0 To CInt(dr.BurstCount) - 1
					For ii As Integer = 0 To dr.ADChannelCount - 1
						mittelwert(ii) += dr.AD(ii).ReadDouble(CULng(i))
					Next ii
				Next i
				For ii As Integer = 0 To dr.ADChannelCount - 1
					mittelwert(ii) /= dr.BurstCount
					Info &= "mittelwert[" & ii & "] : " & mittelwert(ii).ToString() & Environment.NewLine
				Next ii
				MessageBox.Show(Info)

			Catch Ex As Exception
				MessageBox.Show(Info & Environment.NewLine & Ex.Message)
			End Try

		End Sub

		Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
			Try
				If m_bRunning Then
					StopMeasure()
					Return
				End If
				ConfigureMeasurementChannels()
				dev.ADChannels.DataSink.Target = CreateTargetByRadioButton()
				dev.ConfigMeasure()
				dev.ADChannels.DataSink.Enable(Date.Now)

				StartMeasure()
			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub

		Private Function CreateTargetByRadioButton() As IDataSinkTarget
			If rbTargetCSV.Checked Then
				Return CreateTargetCSV()
			End If
			If rbTargetRAW.Checked Then
				Return CreateTargetRAW()
			End If
			If rbTargetSQL.Checked Then
				Return CreateTargetSQL()
			End If
			If rbTargetSQLServer.Checked Then
				Return CreateTargetSQLServer()
			End If
			If rbTargetSQLCe.Checked Then
				Return CreateTargetSQLCe()
			End If
			If rbTargetTDMS.Checked Then
				Return CreateTargetTDMS()
			End If
			If rbTargetTAFFMAT.Checked Then
				Return CreateTargetTaffMat()
			End If
			If rbTargetWAV.Checked Then
				Return CreateTargetWAV()
			End If
			Return Nothing
		End Function





		Private Function CreateTargetCSV() As IDataSinkTarget

			' Modify Parameters and see results.
			Return MAIDataSinkTarget.CreateTargetCSV("Messdaten.csv", "Kanalinfos.csv", False, ";"c, New CultureInfo("en-US"), False)

		End Function

		Private Function CreateTargetRAW() As IDataSinkTarget
'			#Region "Cleanup old Output"
			Dim alte() As String = Directory.GetFiles(".", "Rohdatenmessung.*")
			If alte IsNot Nothing Then
				For Each s As String In alte
					File.Delete(s)
				Next s
			End If
'			#End Region

			Return MAIDataSinkTarget.CreateTargetRAW("Rohdatenmessung", 100000000)
		End Function

		Private Function CreateTargetSQL() As IDataSinkTarget
			Return CreateExplicitSQLCe()
		End Function

		Private Function CreateTargetSQLServer() As IDataSinkTarget
			Dim standard As String = "Server=myServerAddress;Database=myDataBase;User Id=myUsername;Password=myPassword;"
			Dim trusted As String = "Server=myServerAddress;Database=myDataBase;Trusted_Connection=True;"
			Dim SpecifyServerInstance As String = "Server=myServerName\myInstanceName;Database=myDataBase;User Id=myUsername;Password=myPassword;"

			' These are just example strings. You must provide valid connection infos to a database you can access

			Dim conn As New SqlConnection(standard)
			Return MAIDataSinkTarget.CreateTargetSQLServer(conn,"MAIN_Table", "Data", "ChannelInfos", True)
		End Function

		Private Function CreateTargetSQLCe() As IDataSinkTarget
			 Dim s As String = "Output.sdf"
'			 #Region "delete old Output"

			 If File.Exists(s) Then
				File.Delete(s)
			 End If
'			 #End Region

			Return MAIDataSinkTarget.CreateTargetSQLCeFile(s)
		End Function

		Private Function CreateTargetTDMS() As IDataSinkTarget
			Dim alte() As String = Directory.GetFiles(".", "*.TDM")
			If alte IsNot Nothing Then
				For Each s As String In alte
					File.Delete(s)
				Next s
			End If
			alte = Directory.GetFiles(".", "*.TDMS")
			If alte IsNot Nothing Then
				For Each s As String In alte
					File.Delete(s)
				Next s
			End If
		   Return MAIDataSinkTarget.CreateTargetTDMS("TDMS_File", "MeasurementName", "Desctription", "Title", "Author")
			' or maybe create an Explicit Mapping :
		   '    return CreateExplicitTDM();
		End Function

		Private Function CreateTargetTaffMat() As IDataSinkTarget
'			#Region "Cleanup old Output"
			Dim alte() As String = Directory.GetFiles(".", "*.DAT")
			If alte IsNot Nothing Then
				For Each s As String In alte
					File.Delete(s)
				Next s
			End If
			If File.Exists("TaffmatExample.hdr") Then
				File.Delete("TaffmatExample.hdr")
			End If
'			#End Region

			Return MAIDataSinkTarget.CreateTargetTAFFMat("TaffmatExample")

		End Function
		Private Function CreateTargetWAV() As IDataSinkTarget
'			#Region "Cleanup old Output"
			Dim alte() As String = Directory.GetFiles(".", "*.WAV")
			If alte IsNot Nothing Then
				For Each s As String In alte
					File.Delete(s)
				Next s
			End If
'			#End Region

			Return MAIDataSinkTarget.CreateTargetWAV("AudioRecording", 100000000)
		End Function

	End Class
End Namespace
