﻿Imports System.ComponentModel
Imports System.Text
Imports Goldammer.MAIExtensions.DAQ
Imports Goldammer.Helper.OPC
Imports Goldammer
Imports System.Globalization

Namespace TEST_MAI_NET35
	Partial Public Class FormOPCClients
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
			If m_bRunning Then
				StopMeasure()
				button1.Text = "Start"
			Else
				StartMeasure()
				button1.Text = "Stop"

			End If
			rbDA.Enabled = Not m_bRunning
			rbUA.Enabled = Not m_bRunning
			rbXi.Enabled = Not m_bRunning

		End Sub

		Private Sub FormOPCClients_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load

		End Sub

		Private Sub ChangeTarget(ByVal sender As Object, ByVal e As EventArgs) Handles rbDA.CheckedChanged, rbUA.CheckedChanged, rbXi.CheckedChanged
			tbDA_URL.Enabled = rbDA.Checked
			tbUA_URL.Enabled = rbUA.Checked
			tbXiURL.Enabled = rbXi.Checked
			checkBoxTCP.Enabled = rbXi.Checked
			tbXiInstance.Enabled = Not checkBoxTCP.Checked
		End Sub

        Private Function CreateSelectedMap(ByVal Controller As MAIChannelControllerAD) As MAIDataSinkChannelMapOPCBase
            Dim ServerUpdateRate As UInteger = UInteger.Parse(tbServerUpdateRate.Text)

            If rbDA.Checked Then
                Dim serv As Opc.Da.Server = MAIOPCConnectionDA.BuildAndConnect(tbDA_URL.Text, New System.Net.NetworkCredential())
                Dim ret As New MAIDataSinkChannelMapOPCNET20(serv, ServerUpdateRate)
                Dim channels As Dictionary(Of String, Type) = MAIOPCConnectionDA.GetWriteableTagNamesAndDataType(serv)
                For i As Integer = 0 To Controller.MeasurementChannelsCount - 1
                    Dim mchan As MAIMeasurementChannelAD = Controller.GetMeasurementChannel(CUInt(i))
                    Dim opcname As String = "ADChannels.Device1.Analog" & (i + 1).ToString()
                    For Each c As KeyValuePair(Of String, Type) In channels
                        If c.Key.Contains(opcname) Then
                            ret.AddTargetForChannel(mchan, c.Key, Nothing)
                        End If
                    Next c
                Next i
                Return ret
            ElseIf rbUA.Checked Then
                Dim sessi As Opc.Ua.Client.Session = MAIOPCConnectionUA.BuildSessionAndConnect(tbUA_URL.Text)
                Dim ret As New MAIDataSinkChannelMapOPCUA(sessi, ServerUpdateRate)
                Dim channels As Dictionary(Of Opc.Ua.NodeId, Type) = MAIOPCConnectionUA.BrowseSessionForWriteableTags(sessi)
                For i As Integer = 0 To Controller.MeasurementChannelsCount - 1
                    Dim mchan As MAIMeasurementChannelAD = Controller.GetMeasurementChannel(CUInt(i))
                    Dim opcname As String = "ADChannels.Device1.Analog" & (i + 1).ToString()
                    For Each c As KeyValuePair(Of Opc.Ua.NodeId, Type) In channels
                        If c.Key.Identifier.ToString().Contains(opcname) Then
                            ret.AddTargetForChannel(mchan, c.Key, Nothing)
                        End If
                    Next c
                Next i
                Return ret
            ElseIf rbXi.Checked Then
                Dim conti As Xi.Client.Base.API.IXiContext = MAIOPCConnectionXi.BuildContextFromDiscoveryServerInfoAndSubscribeToWriteEndpoint(tbXiURL.Text, tbXiInstance.Text, MAIOPCConnectionXiType.TCP)
                Dim ret As New MAIDataSinkChannelMapOPCXi(conti, ServerUpdateRate)
                Dim channels As Dictionary(Of Xi.Contracts.Data.InstanceId, Type) = MAIOPCConnectionXi.BrowseContextForWriteableTags(conti)
                For i As Integer = 0 To Controller.MeasurementChannelsCount - 1
                    Dim mchan As MAIMeasurementChannelAD = Controller.GetMeasurementChannel(CUInt(i))
                    Dim opcname As String = "ADChannels.Device1.Analog" & (i + 1).ToString()
                    For Each c As KeyValuePair(Of Xi.Contracts.Data.InstanceId, Type) In channels
                        If c.Key.FullyQualifiedId.Contains(opcname) Then
                            ret.AddTargetForChannel(mchan, c.Key, Nothing)
                        End If
                    Next c
                Next i
                Return ret
            End If

            Throw New Exception("CreateSelectedMap: unexpected error.")

        End Function


		Private Sub StartMeasure()
			If dev Is Nothing Then
                dev = Goldammer.MAI.Devices(0)
			End If
			dev.ClearAllChannelLists()

			dev.ADChannels(0).CreateMeasurementChannel(OversamplingMode.Disabled, GainFactor.Disabled, True)
			dev.ADChannels(1).CreateMeasurementChannel(OversamplingMode.Disabled, GainFactor.Disabled, True)
			dev.ADChannels(2).CreateMeasurementChannel(OversamplingMode.Disabled, GainFactor.Disabled, True)
			dev.ADChannels(3).CreateMeasurementChannel(OversamplingMode.Disabled, GainFactor.Disabled, True)

			dev.ADChannels.SetSampleRate(100)
			Dim myMAP As MAIDataSinkChannelMapOPCBase = CreateSelectedMap(dev.ADChannels)

			 dev.ADChannels.DataSink.Target = MAIDataSinkTarget.CreateTargetOPC(myMAP)
			dev.ConfigMeasure()
			dev.ADChannels.DataSink.Enable(Date.Now)
			dev.CTChannels.DataSink.Enable(Date.Now)

			dev.StartMeasure()
			m_bRunning = True
		End Sub

		Private Sub StopMeasure()
			If dev Is Nothing Then
				Return
			End If
			m_bRunning = False
			dev.StopMeasure()
			dev.ADChannels.DataSink.Disable()
			dev.CTChannels.DataSink.Disable()

			dev.ADChannels.DataSink.Target = Nothing
			dev.CTChannels.DataSink.Target = Nothing
			dev.ClearAllChannelLists()
		End Sub

		Private dev As MAIDevice = Nothing
		Private m_bRunning As Boolean = False

		Private Sub timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles timer1.Tick
			If Not m_bRunning Then
				Return
			End If
			If dev Is Nothing Then
				Return
			End If
			If dev.ADChannels.DataSink.Target Is Nothing Then
				Return
			End If

			tbBurstsrecorded.Text = dev.ADChannels.DataSink.BurstCount.ToString()



		End Sub

		Private Sub checkBoxTCP_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles checkBoxTCP.CheckedChanged
			tbXiInstance.Enabled = Not checkBoxTCP.Checked
		End Sub

	End Class
End Namespace
