﻿Imports System.ComponentModel
Imports System.Text
Imports System.Windows.Forms.DataVisualization.Charting
Imports Goldammer
Imports Goldammer.MAIExtensions.DAQ
Imports System.Globalization

Namespace DatasinkPreviewDemo
	Partial Public Class MAIN
		Inherits Form
		Private m_dev As MAIDevice

		Public Sub New()
			InitializeComponent()
            m_dev = Goldammer.MAI.Devices(0)
			If m_dev IsNot Nothing Then
				For Each s As MAIChannelAD In m_dev.ADChannels
					checkedListBox1.Items.Add(s.HardwareChannelNumber, True)
				Next s
			End If
		End Sub



		Private NumberOfSeries As Integer = 0
		Private RMSArray() As Double
		Private MAXArray() As Double
		Private Sub SetupChart()
			NumberOfSeries = checkedListBox1.CheckedItems.Count
			RMSArray = New Double(NumberOfSeries - 1){}
			MAXArray = New Double(NumberOfSeries - 1){}
			chart1.Series.Clear()
			chart1.ChartAreas.Clear()
			Dim na As ChartArea
			Dim ns As Series
			For i As Integer = 0 To NumberOfSeries - 1
				ns = chart1.Series.Add(i.ToString())
				ns.ChartType = SeriesChartType.FastLine

				' Der folgende Teil konfiguriert das Chart zum RogaREC lookalike:
				' wenn Sie das auskommentieren, wird alles in ein Koodinatensystem gemalt
				ns.Color = Color.Red
				na = chart1.ChartAreas.Add(i.ToString())
				ns.ChartArea = na.Name
				na.AlignmentOrientation = AreaAlignmentOrientations.Horizontal
				na.Position.X = 5
				na.Position.Y = (100 \ checkedListBox1.CheckedItems.Count) * i
				na.Position.Width = 90
				na.Position.Height = 100 \ checkedListBox1.CheckedItems.Count
				na.AxisX.LabelStyle.Enabled = False
				na.AxisX.MajorTickMark.Enabled = False
				na.AxisX.Enabled = AxisEnabled.False
				na.AxisY.Maximum = 10
				na.AxisY.Minimum = -10
				na.AxisY.MajorGrid.Interval = 10
				na.AxisY.MinorGrid.Interval = 1
				na.AxisY.MinorGrid.Enabled = True
				na.AxisY.MinorGrid.LineColor = Color.LightGray
				na.AxisY.MinorTickMark.Enabled = True
				na.AxisY.MajorTickMark.Interval = 10
				na.AxisY.LabelStyle.Interval = 10

			Next i

		End Sub

		Private DisplayPoints As Integer
		Private DisplayRate As Integer

		Private Sub button3_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button3.Click
			' ändert die Konfiguration bzw. startet die Anzeige beim ersten Klick
			timer1.Enabled = False
			StopMeasurement()
			SetupChart()
			DisplayPoints = Convert.ToInt32(textBoxDisplayPoints.Text)
			DisplayRate = Convert.ToInt32(textBoxDisplayRate.Text)
			StartMeasurement()
			timer1.Enabled = True
		End Sub

		Private Sub StopMeasurement()
			If m_dev Is Nothing Then
				Return
			End If
			m_dev.ADChannels.DataSink.Disable()
			m_dev.StopMeasure()
			m_dev.ClearAllChannelLists()
		End Sub

		Private Sub StartMeasurement()
			If m_dev Is Nothing Then
				Return
			End If
			m_dev.ADChannels.DataSink.Disable()
			m_dev.StopMeasure() ' Messung anhalten
			m_dev.ClearAllChannelLists() ' Kanallisten löschen
			m_dev.ADChannels.DataSink.Target = MAIDataSinkTarget.CreateTargetCSV(textBoxOutFile.Text, False, " "c, New CultureInfo("en-US")) ' CSV Target anhängen
			For i As Integer = 0 To checkedListBox1.CheckedIndices.Count - 1 ' Messkanäle definieren
				m_dev.ADChannels(checkedListBox1.CheckedIndices(i)).CreateMeasurementChannel(OversamplingMode.Disabled, GainFactor.Disabled, True)
			Next i
			m_dev.ADChannels.SetSampleRate(Convert.ToDouble(textBoxSamplerate.Text)) ' Sample Rate setzen
			m_dev.ConfigMeasure()
			m_dev.ADChannels.DataSink.Enable(Date.Now) ' Datasink starten
			' jetzt das Preview konfigurieren:
			m_dev.ADChannels.DataSink.Preview.MaxTickCount = CUInt(DisplayPoints)
			m_dev.ADChannels.DataSink.Preview.TickFrequency = DisplayRate
			m_dev.ADChannels.DataSink.Preview.Enabled = True
			' und nur Daten aufzeichnen, wenn "Recording" im UI aktiviert ist:
			m_dev.ADChannels.DataSink.OutputEnabled = checkBox1.Checked
			m_dev.StartMeasure()
		End Sub

		Private Sub timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles timer1.Tick
			Try
				Dim i As Integer = 0
				m_dev.ADChannels.DataSink.Preview.Update() ' Preview aktualisieren
				For Each s As Series In chart1.Series ' für alle Graphen
					RMSArray(i) = m_dev.ADChannels.DataSink.Preview.GetRootMeanSquare(i)
					MAXArray(i) = m_dev.ADChannels.DataSink.Preview.GetBufferMax(i)
					s.Points.DataBindXY(m_dev.ADChannels.DataSink.Preview.Timestamps, m_dev.ADChannels.DataSink.Preview(i)) ' Setze die Punkte aus dem Datasink Preview
					i += 1
				Next s
				chart2.Series("RMS").Points.DataBindY(RMSArray)
				chart2.Series("Maximum").Points.DataBindY(MAXArray)

			Catch
			End Try
		End Sub

		Private Sub MAIN_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles MyBase.FormClosed
			timer1.Enabled = False
			StopMeasurement()
		End Sub

		Private Sub checkBox1_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles checkBox1.CheckedChanged
			If m_dev Is Nothing Then
				Return
			End If
			m_dev.ADChannels.DataSink.OutputEnabled = checkBox1.Checked ' Wenn "Record" hineingedrückt ist, werden Daten geschrieben, sonst nicht.
		End Sub

		Private Sub rbVIewChart_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles rbVIewChart.CheckedChanged
			chart1.Visible = rbVIewChart.Checked
			chart2.Visible = rbViewBars.Checked
		End Sub





	End Class
End Namespace
