﻿Imports System.Text
Imports OpcCom.Da
Imports System.Net


Namespace Goldammer.Helper.OPC
	''' <summary>
	''' This class is compatible to .net Framework 2.0
	''' </summary>
	Public Class MAIOPCConnectionDA

		#Region "private"

        Private Shared Sub BrowseForChildTags(ByVal ServerToBrowse As Global.Opc.Da.Server, ByVal ItemName As String, ByVal Dict As Dictionary(Of String, Type))

            Dim filt As New Global.Opc.Da.BrowseFilters()
            filt.MaxElementsReturned = 1000
            filt.ReturnAllProperties = True
            filt.ReturnPropertyValues = True
            filt.ElementNameFilter = ""
            filt.BrowseFilter = Global.Opc.Da.browseFilter.all
            Dim id As New Global.Opc.Da.Item()
            id.ItemName = ItemName
            Dim pos As Global.Opc.Da.BrowsePosition
            Dim elms() As Global.Opc.Da.BrowseElement = ServerToBrowse.Browse(id, filt, pos)
            If elms IsNot Nothing Then
                For Each e As Global.Opc.Da.BrowseElement In elms
                    If e.HasChildren Then
                        BrowseForChildTags(ServerToBrowse, e.ItemName, Dict)
                    End If
                    If e.Properties IsNot Nothing Then
                        If Not IsWriteable(e) Then
                            Continue For
                        End If
                        If e.Properties(0).Description.Contains("Item Canonical Data Type") Then
                            Dim s As System.Object = e.Properties(0).Value
                            Dict.Add(e.ItemName, CType(s, System.Type))
                        End If
                    End If

                Next e
            End If

        End Sub

        Private Shared Function IsWriteable(ByVal Elem As Global.Opc.Da.BrowseElement) As Boolean
            For Each p As Global.Opc.Da.ItemProperty In Elem.Properties
                If p.Description.Contains("Item Access Rights") Then
                    If ((CInt(Fix(p.Value))) And 2) = 2 Then
                        Return True
                    End If
                End If
            Next p
            Return False
        End Function

		#End Region

        Public Shared Function BuildAndConnect(ByVal ServerURL As String, ByVal Credentials As NetworkCredential) As Global.Opc.Da.Server
            Dim url As New Global.Opc.URL(ServerURL)
            Dim factory As New Global.OpcCom.Factory(True)
            Dim server As New Global.Opc.Da.Server(factory, url)
            server.Connect(url, New Global.Opc.ConnectData(Credentials))
            Return server
        End Function

        Public Shared Function GetWriteableTagNamesAndDataType(ByVal ServerToBrowse As Global.Opc.Da.Server) As Dictionary(Of String, Type)
            Dim ret As New Dictionary(Of String, Type)()
            BrowseForChildTags(ServerToBrowse, "", ret)
            Return ret
        End Function

	End Class
End Namespace
